# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class CreateAccountRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        CreateAccountRequest - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'bank_account_id': 'str',
            'member_id': 'str',
            'member_public_key': 'str',
            'member_pin_public_key': 'str',
            'name': 'str'
        }

        self.attribute_map = {
            'bank_account_id': 'bankAccountId',
            'member_id': 'memberId',
            'member_public_key': 'memberPublicKey',
            'member_pin_public_key': 'memberPinPublicKey',
            'name': 'name'
        }

        self._bank_account_id = None
        self._member_id = None
        self._member_public_key = None
        self._member_pin_public_key = None
        self._name = None

    @property
    def bank_account_id(self):
        """
        Gets the bank_account_id of this CreateAccountRequest.


        :return: The bank_account_id of this CreateAccountRequest.
        :rtype: str
        """
        return self._bank_account_id

    @bank_account_id.setter
    def bank_account_id(self, bank_account_id):
        """
        Sets the bank_account_id of this CreateAccountRequest.


        :param bank_account_id: The bank_account_id of this CreateAccountRequest.
        :type: str
        """
        self._bank_account_id = bank_account_id

    @property
    def member_id(self):
        """
        Gets the member_id of this CreateAccountRequest.


        :return: The member_id of this CreateAccountRequest.
        :rtype: str
        """
        return self._member_id

    @member_id.setter
    def member_id(self, member_id):
        """
        Sets the member_id of this CreateAccountRequest.


        :param member_id: The member_id of this CreateAccountRequest.
        :type: str
        """
        self._member_id = member_id

    @property
    def member_public_key(self):
        """
        Gets the member_public_key of this CreateAccountRequest.


        :return: The member_public_key of this CreateAccountRequest.
        :rtype: str
        """
        return self._member_public_key

    @member_public_key.setter
    def member_public_key(self, member_public_key):
        """
        Sets the member_public_key of this CreateAccountRequest.


        :param member_public_key: The member_public_key of this CreateAccountRequest.
        :type: str
        """
        self._member_public_key = member_public_key

    @property
    def member_pin_public_key(self):
        """
        Gets the member_pin_public_key of this CreateAccountRequest.


        :return: The member_pin_public_key of this CreateAccountRequest.
        :rtype: str
        """
        return self._member_pin_public_key

    @member_pin_public_key.setter
    def member_pin_public_key(self, member_pin_public_key):
        """
        Sets the member_pin_public_key of this CreateAccountRequest.


        :param member_pin_public_key: The member_pin_public_key of this CreateAccountRequest.
        :type: str
        """
        self._member_pin_public_key = member_pin_public_key

    @property
    def name(self):
        """
        Gets the name of this CreateAccountRequest.


        :return: The name of this CreateAccountRequest.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this CreateAccountRequest.


        :param name: The name of this CreateAccountRequest.
        :type: str
        """
        self._name = name

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()
