# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class CreateDeviceRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        CreateDeviceRequest - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'name': 'str',
            'login_timeout': 'str',
            'push_notification_id': 'str',
            'public_key': 'str'
        }

        self.attribute_map = {
            'name': 'name',
            'login_timeout': 'loginTimeout',
            'push_notification_id': 'pushNotificationId',
            'public_key': 'publicKey'
        }

        self._name = None
        self._login_timeout = None
        self._push_notification_id = None
        self._public_key = None

    @property
    def name(self):
        """
        Gets the name of this CreateDeviceRequest.


        :return: The name of this CreateDeviceRequest.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this CreateDeviceRequest.


        :param name: The name of this CreateDeviceRequest.
        :type: str
        """
        self._name = name

    @property
    def login_timeout(self):
        """
        Gets the login_timeout of this CreateDeviceRequest.


        :return: The login_timeout of this CreateDeviceRequest.
        :rtype: str
        """
        return self._login_timeout

    @login_timeout.setter
    def login_timeout(self, login_timeout):
        """
        Sets the login_timeout of this CreateDeviceRequest.


        :param login_timeout: The login_timeout of this CreateDeviceRequest.
        :type: str
        """
        self._login_timeout = login_timeout

    @property
    def push_notification_id(self):
        """
        Gets the push_notification_id of this CreateDeviceRequest.


        :return: The push_notification_id of this CreateDeviceRequest.
        :rtype: str
        """
        return self._push_notification_id

    @push_notification_id.setter
    def push_notification_id(self, push_notification_id):
        """
        Sets the push_notification_id of this CreateDeviceRequest.


        :param push_notification_id: The push_notification_id of this CreateDeviceRequest.
        :type: str
        """
        self._push_notification_id = push_notification_id

    @property
    def public_key(self):
        """
        Gets the public_key of this CreateDeviceRequest.


        :return: The public_key of this CreateDeviceRequest.
        :rtype: str
        """
        return self._public_key

    @public_key.setter
    def public_key(self, public_key):
        """
        Sets the public_key of this CreateDeviceRequest.


        :param public_key: The public_key of this CreateDeviceRequest.
        :type: str
        """
        self._public_key = public_key

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other): 
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """ 
        Returns true if both objects are not equal
        """
        return not self == other

