# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class CreateTransferRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        CreateTransferRequest - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'payer_bank_code': 'str',
            'payee_bank_code': 'str',
            'amount': 'Money'
        }

        self.attribute_map = {
            'payer_bank_code': 'payerBankCode',
            'payee_bank_code': 'payeeBankCode',
            'amount': 'amount'
        }

        self._payer_bank_code = None
        self._payee_bank_code = None
        self._amount = None

    @property
    def payer_bank_code(self):
        """
        Gets the payer_bank_code of this CreateTransferRequest.


        :return: The payer_bank_code of this CreateTransferRequest.
        :rtype: str
        """
        return self._payer_bank_code

    @payer_bank_code.setter
    def payer_bank_code(self, payer_bank_code):
        """
        Sets the payer_bank_code of this CreateTransferRequest.


        :param payer_bank_code: The payer_bank_code of this CreateTransferRequest.
        :type: str
        """
        self._payer_bank_code = payer_bank_code

    @property
    def payee_bank_code(self):
        """
        Gets the payee_bank_code of this CreateTransferRequest.


        :return: The payee_bank_code of this CreateTransferRequest.
        :rtype: str
        """
        return self._payee_bank_code

    @payee_bank_code.setter
    def payee_bank_code(self, payee_bank_code):
        """
        Sets the payee_bank_code of this CreateTransferRequest.


        :param payee_bank_code: The payee_bank_code of this CreateTransferRequest.
        :type: str
        """
        self._payee_bank_code = payee_bank_code

    @property
    def amount(self):
        """
        Gets the amount of this CreateTransferRequest.


        :return: The amount of this CreateTransferRequest.
        :rtype: Money
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """
        Sets the amount of this CreateTransferRequest.


        :param amount: The amount of this CreateTransferRequest.
        :type: Money
        """
        self._amount = amount

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other): 
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """ 
        Returns true if both objects are not equal
        """
        return not self == other

