# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class GetChargeResponseTerms(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        GetChargeResponseTerms - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'amount': 'Money',
            'count': 'int',
            'max_amount': 'Money',
            'max_count': 'Object',
            'commences': 'str',
            'expires': 'str'
        }

        self.attribute_map = {
            'amount': 'amount',
            'count': 'count',
            'max_amount': 'maxAmount',
            'max_count': 'maxCount',
            'commences': 'commences',
            'expires': 'expires'
        }

        self._amount = None
        self._count = None
        self._max_amount = None
        self._max_count = None
        self._commences = None
        self._expires = None

    @property
    def amount(self):
        """
        Gets the amount of this GetChargeResponseTerms.


        :return: The amount of this GetChargeResponseTerms.
        :rtype: Money
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """
        Sets the amount of this GetChargeResponseTerms.


        :param amount: The amount of this GetChargeResponseTerms.
        :type: Money
        """
        self._amount = amount

    @property
    def count(self):
        """
        Gets the count of this GetChargeResponseTerms.


        :return: The count of this GetChargeResponseTerms.
        :rtype: int
        """
        return self._count

    @count.setter
    def count(self, count):
        """
        Sets the count of this GetChargeResponseTerms.


        :param count: The count of this GetChargeResponseTerms.
        :type: int
        """
        self._count = count

    @property
    def max_amount(self):
        """
        Gets the max_amount of this GetChargeResponseTerms.


        :return: The max_amount of this GetChargeResponseTerms.
        :rtype: Money
        """
        return self._max_amount

    @max_amount.setter
    def max_amount(self, max_amount):
        """
        Sets the max_amount of this GetChargeResponseTerms.


        :param max_amount: The max_amount of this GetChargeResponseTerms.
        :type: Money
        """
        self._max_amount = max_amount

    @property
    def max_count(self):
        """
        Gets the max_count of this GetChargeResponseTerms.


        :return: The max_count of this GetChargeResponseTerms.
        :rtype: Object
        """
        return self._max_count

    @max_count.setter
    def max_count(self, max_count):
        """
        Sets the max_count of this GetChargeResponseTerms.


        :param max_count: The max_count of this GetChargeResponseTerms.
        :type: Object
        """
        self._max_count = max_count

    @property
    def commences(self):
        """
        Gets the commences of this GetChargeResponseTerms.


        :return: The commences of this GetChargeResponseTerms.
        :rtype: str
        """
        return self._commences

    @commences.setter
    def commences(self, commences):
        """
        Sets the commences of this GetChargeResponseTerms.


        :param commences: The commences of this GetChargeResponseTerms.
        :type: str
        """
        self._commences = commences

    @property
    def expires(self):
        """
        Gets the expires of this GetChargeResponseTerms.


        :return: The expires of this GetChargeResponseTerms.
        :rtype: str
        """
        return self._expires

    @expires.setter
    def expires(self, expires):
        """
        Sets the expires of this GetChargeResponseTerms.


        :param expires: The expires of this GetChargeResponseTerms.
        :type: str
        """
        self._expires = expires

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()
